/*
    Spatiile de Nume (namespaces) sunt zone din program, cuprinse intre acolade,
    introduse cu cuvantul "namespace" urmat de un nume, care PROTEJEAZA 
    numele de variabile, functii, clase, definite in interior,
    de nume identice definite in exteriorul spatiului de nume.

 */

#include <iostream>

namespace MySpace {
    int x = 10;
    void F()
    {
        std::cout << __FUNCTION__ << '\n';
    }

    class Book {
    public:
        Book()
        {
            std::cout << __FUNCTION__ << '\n';
        }
    };
}

/*
    :: Scope Resolution Operator 
       (Operator de Rezolvare a Domeniului)

    () - operator functie:  Ex: F(x)
    () - operator grupare:  a * (b + c)
    () - operator de conversie:
         std::cout << (int)'A'; 
   
    [] - operator de indexare: Ex: a[i]

    ....

    ,
*/

int main()
{
    std::cout << MySpace::x << '\n';
    MySpace::F();
    MySpace::Book book;

}
